# Contributing

## First steps

Thank you for getting involved! Before you start, please familiarize yourself with the [documentation](https://docs.edgeless.systems/constellation).

Please follow our [Code of Conduct](CODE_OF_CONDUCT.md) when interacting with this project.

If you want to support our development:

* Add a GitHub Star to the project
* Share our projects on social media
* Join the [Confidential Computing Discord](https://discord.gg/rH8QTH56JN)

Constellation is licensed under the [AGPLv3](LICENSE). When contributing, you also need to agree to our [Contributor License Agreement](https://cla-assistant.io/edgelesssys/constellation).

## Reporting issues and bugs, asking questions

This project uses the GitHub issue tracker. Check the existing issues before submitting to avoid duplicates.

Please report any security issue via a [private GitHub vulnerability report](https://github.com/edgelesssys/constellation/security/advisories/new) or write to <security@edgeless.systems>.

Your bug report should cover the following points:

* A quick summary and/or background of the issue
* Steps to reproduce (be specific, e.g., provide sample code)
* What you expected would happen
* What actually happens
* Further notes:
  * Thoughts on possible causes
  * Tested workarounds or fixes

## Contributing a pull request

See the [pull request workflow](./dev-docs/workflows/pull-request.md).

## Developer docs

We have some documentation, guidelines and conventions that you can go through to familiarize yourself with the project and get started hacking on it.

Here are some useful links inside `dev-docs`:

* Building, testing, deploying: [local development](/dev-docs/workflows/build-develop-deploy.md)
* [General conventions](/dev-docs/conventions.md)
* [PR conventions](/dev-docs/workflows/pull-request.md#conventions)
* [Repository layout](/dev-docs/layout.md#repository-layout)
* [Upgrading Kubernetes](/dev-docs/workflows/upgrade-kubernetes.md)
